#include "NoDefLib.h"
#include <windows.h>

char *TempStr;

char *s_strcpy(char *Destination,const char *Source)
{
	int SourceLen = strlen(Source)+1;
	__asm{
		mov  ecx, SourceLen
		mov  edi, Destination
		mov  esi, Source
		cld
		rep  movsb
	}
	return Destination;
}

void WINAPI MakeStr(char *String)
{
	int CharCount = 0;
	while(String[CharCount]!=0){
		if (String[CharCount]!=0x0A) 
			String[CharCount]=((String[CharCount]-0x20)^0x77)+0x20;
		CharCount++;
	};
	return;
}

void WINAPI UnTranslate(char *Source)
{
	char *Dest = (char *) GlobalAlloc(0x40,4*MAX_PATH);
	int CharSCount = 0;
	int CharDCount = 0;
	while(Source[CharSCount]!=0){
		byte Simbol = Source[CharSCount];
		if ((Simbol<64)||((Simbol>126)&&(Simbol<192))){
			Dest[CharDCount] = '\\';
			CharDCount++;
			switch(Source[CharSCount]){
				case 0x9: 
					Dest[CharDCount] = 't';
					break;
				case 0xD: 
					Dest[CharDCount] = 'r';
					break;
				case 0xA: 
					Dest[CharDCount] = 'n';
					break;
				default:
					Dest[CharDCount] = (Source[CharSCount]&0xC0)>>6|0x30;
					Dest[CharDCount+1] = (Source[CharSCount]&0x38)>>3|0x30;
					Dest[CharDCount+2] = (Source[CharSCount]&0x7)+0x30;
					CharDCount+=2;
					break;
				};
		}else Dest[CharDCount] = Source[CharSCount];
		CharSCount++;
		CharDCount++;
	};
	Dest[CharDCount] = 0x0;
	s_strcpy(Source,Dest);
	GlobalFree(Dest);
	return;
}
 
void WINAPI Translate(char *Source)
{
	char *Dest = (char *) GlobalAlloc(0x40, 4*MAX_PATH);
	int CharSCount = 0;
	int CharDCount = 0;
	while(Source[CharSCount]!=0){
		if (Source[CharSCount]!=0x5C) goto no_operation;
		CharSCount++;
		switch(Source[CharSCount]){
		case 0x5C: 
			Dest[CharDCount] = 0x5C;
			goto dest_count;
		case '0':case '1':case '2':case '3':case '4':case '5':case '6':case '7':case '8':case '9':
			Dest[CharDCount] = (Source[CharSCount]-0x30)<<6|(Source[CharSCount+1]-0x30)<<3|(Source[CharSCount+2]-0x30);
			CharSCount+=2;
			goto sdest_count;
		case 'T':case 't':
			Dest[CharDCount] = 0x9;
			goto sdest_count;
		case 'R':case 'r':
			Dest[CharDCount] = 0xD;
			goto sdest_count;
		case 'N':case 'n':
			Dest[CharDCount] = 0xA;
			goto sdest_count;
		default: break;
		}
no_operation:
		Dest[CharDCount] = Source[CharSCount];
sdest_count:
		CharSCount++;
dest_count:
		CharDCount++;
	};
	Dest[CharDCount] = 0x0;
	s_strcpy(Source,Dest);
	GlobalFree(Dest);
	return;
}

int	WINAPI DialogProc(HWND hWin, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg){
	case WM_INITDIALOG:
		SendMessage(hWin,WM_SETTEXT,0,LPARAM("Total Commander String Coder/Decoder by NetSpider"));
		TempStr = (char *) GlobalAlloc(0x40, 4*MAX_PATH);
		break;
	case WM_COMMAND:
		switch(wParam){
		case 1002:
				GetDlgItemText(hWin, 1001, TempStr, MAX_PATH);
				MakeStr(TempStr);
				UnTranslate(TempStr);
				SetDlgItemText(hWin, 1001, TempStr);
				break;
		case 1003:
				GetDlgItemText(hWin, 1001, TempStr, MAX_PATH);
				Translate(TempStr);
				MakeStr(TempStr);
				SetDlgItemText(hWin, 1001, TempStr);
				break;
		case 1004:
				EndDialog(hWin,0);
				GlobalFree(TempStr);
				break;
		}
		break;
	case WM_CLOSE: 
		EndDialog(hWin,0);
		GlobalFree(TempStr);
		break;
	default: return 0;
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine, int nCmdShow)
{
	DialogBoxParam(hInst,"1000",0, &DialogProc, 0);
	return 0;
}