#ifndef NODEFLIB_H
#define NODEFLIB_H

#include <windows.h>

//Use own function for MemoryManagment and Code Exec Protection
//To UnEnable use, example, //#define Use_CodeProtection_MemoryManager
#define Use_CodeProtection_MemoryManager

//#pragma comment(linker, "/MERGE:.rdata=.text") 
//#pragma comment(linker, "/MERGE:.data=.text") 
//#pragma comment(linker, "/FILEALIGN:512 /SECTION:.text,ERw /IGNORE:4078") 
//#pragma comment(linker, "/FILEALIGN:512 /SECTION:.text,ER /IGNORE:4078") 
#pragma comment(linker, "/ENTRY:New_WinMain") 
#pragma comment(linker, "/NODEFAULTLIB") 
#pragma comment(linker, "/SUBSYSTEM:WINDOWS") 

//Our own Library Function's
//------------------------------------------------------------------------------------------------
#ifdef Use_CodeProtection_MemoryManager

extern void __stdcall EnterCriticalCode();
extern void __stdcall LeaveCriticalCode();
extern LPVOID __stdcall MemAlloc(DWORD dwBytes);
extern LPVOID __stdcall MemReAlloc(void *hMem,DWORD dwBytes);
extern BOOL __stdcall MemFree(void *hMem);

#endif
//------------------------------------------------------------------------------------------------

int WINAPI WinMain(
    IN HINSTANCE hInstance,
    IN HINSTANCE hPrevInstance,
    IN LPSTR lpCmdLine,
    IN int nShowCmd
    );

#endif /* !NODEFLIB_H */